#ifndef _h_dag_
#define _h_dag_

#include "scoring.h"
SEXP dag_to_graph(dag_ctx,const char *);


typedef struct DagState {
  int   n,k,kk;
  char *fanIn,*fanOut;
  char *adjM,*parent,*child;
  char *stack,*color;
} *DagState;

DagState DagStateInit(int n,int k,int kk);
int      DagStateAdd(DagState ds,int a,int b,int cycleCheck);
int      DagStateDel(DagState ds,int a,int b,int connectCheck);
int      DagStateHasEdge(DagState ds,int a,int b);
char    *DagStateParentSet(DagState ds,int a);
#endif
