#ifndef _h_scores_
#define _h_scores_

#include <Rinternals.h>

typedef struct scoring {
  SEXP data;
  SEXP metric;
  int  vars;
  int  keysize;
  char key[0];
} *scoring_t;

extern SEXP scoring_tag;

#define SCORING(SE)     ((scoring_t)R_ExternalPtrAdd(EPTR(SE)))
#define SCORING_REF(X)  R_MakeExternalPtr((X),scoring_tag,R_NilValue)
#define IS_SCORING(SE)  (TYPEOF((SE)) == VECSXP && TYPEOF(EPTR(SE)) == EXTPTRSXP && R_ExternalPtrTag(EPTR(SE)) == scoring_tag)




#endif
