optimize.order.sa <- function(d,o,m,mode="int",N=1000,T.0=50,T.N=1)
  .Call("BNSL_SimulatedAnnealing",d,as.integer(o),as.integer(m),
        match(mode,c("int","max","min")),as.integer(N),
        as.numeric(T.0),as.numeric(T.N))

optimize.order.greedy <- function(d,m,o=NULL,time=Inf,mode="int") 
	.Call("BNSL_GreedyOptimization",d,as.integer(m),
	      if(is.null(o)) NULL else as.integer(o),
              match(mode,c("int","max","min")),
              as.numeric(time))


#optimize.order.greedy <- function(d,o,m,mode="int")
#  .Call("BNSL_GreedySearch",d,as.integer(o),as.integer(m),
#        match(mode,c("int","max","min")))
