LogSumExp <- function(v)        .Call("BNSL_LogSumExp",as.numeric(v))
orderSet  <- function(o,s=NULL,skip=0,thin=1)
  .Call("BNSL_OrderSet",o,s,as.integer(skip),as.integer(thin))

graph.order.match <- function(edgelist,o)
  .Call("BNSL_OrderConsistency",edgelist,as.integer(o),DUP=FALSE)

temp.ladder = function(min.temp,max.temp,N) {
	delta = (log(max.temp)-log(min.temp))/(N-1)
	temps = exp(log(max.temp)-seq(N-1,0)*delta)
	temps[1] = min.temp
	temps
}

energy.ladder = function(min.energy,max.energy,N) {
	delta = (log(max.energy-min.energy)-log(2))/(N-1)
	energies = exp(log(max.energy-min.energy)-delta*seq(N,1))+min.energy
	energies[1] = -Inf
	energies
}
