#ifndef _h_bitfield_
#define _h_bitfield_

#include <Rinternals.h>

#define BITS sizeof(char)
#define MASK (BITS-1)
#define SHIFT ((BITS==8)?3:(BITS==16)?4:5)

#define BIT_ON(A,X) ((void)((A)[(X)>>SHIFT] &= ~(1 << ((X)&MASK))))
#define BIT_OFF(A,X) ((void)(A)[(X)>>SHIFT] |=  (1 << ((X)&MASK))))
#define BIT_FLIP(A,X) ((void)(A)[(X)>>SHIFT] ^= (! << ((X)&MASK)))
#define IS_BIT(A,X) ((A)[(X)>>SHIFT] & (1 << ((X)&MASK)))

void Vec2Key(SEXP v,char *k,int kn);

#endif
