#include <Rdefines.h>
#include "common.h"
#include "bitstring.h"
#include <db.h>
#include <Rmath.h>
#include "fastdb.h"

#define SWAP(X,Y) X^=Y;Y^=X;X^=Y

SEXP BNSL_DagMCMC(SEXP d,SEXP max_parents,SEXP _N,
		  SEXP start) {
  fast_score_ctx ctx = fast_ctx(d,asInteger(max_parents));
  GetRNGstate();
  int B = INTEGER(_N)[0];
  int N = INTEGER(_N)[0]+INTEGER(_N)[1];
  
  SEXP ret,scores,dags;
  PROTECT(scores = allocVector(REALSXP,N));
  PROTECT(dags   = allocVector(VECSXP,N));
  

  PutRNGstate();
  UNPROTECT(2);
  return scores;
}
