typedef struct pset_dag_ctx {
  DB     *db;
  int     n,k,kk;
  int     rl;
  char   *adjM;
  char   *fanIn,*fanOut;
  char   *parent,*child;
  char   *stack,*color;
  double *score;
  int     edges;
  int     scalefree;
  double  gamma;
  int     scoring;
} *pset_dag_ctx;

pset_dag_ctx pset_dag(SEXP D,int k,int kk,int scoring);

double pset_dag_add_propose(pset_dag_ctx,int a,int b,int acyclic);
double pset_dag_del_propose(pset_dag_ctx,int a,int b,int connected);
SEXP   pset_dag_state(pset_dag_ctx);
