#include <Rdefines.h>
#include <db.h>
#include "common.h"
#include "dag.h"

extern int unif_int(int n);

void InitChainDag(DagState ds) {
  int i;

  /* Generate a Yates-Shuffle order */
  char *order = R_alloc(sizeof(char),ds->n);
  for(i=0;i<ds->n;i++) order[i] = i;
  /* Do the swaps */
  for(i=0;i<ds->n;i++) {
    int  j = i+unif_int(ds->n-i);
    order[i] ^= order[j];
    order[j] ^= order[i];
    order[i] ^= order[j];
  }


  

}


SEXP BNSL_RandomDag(SEXP _ITER,SEXP _N,SEXP _K,SEXP _KK) {
  char *vmax = vmaxget();
  DagState ds= DagStateInit(INTEGER(_N)[0],INTEGER(_K)[0],INTEGER(_KK)[0]);

  


  
  vmaxset(vmax);
  return R_NilValue;
}

