#include <Rinternals.h>
#include <db.h>

SEXP BNSL_InvertOrders(SEXP orders) {
  SEXP ret;
  int i,j;
  PROTECT(ret = allocVector(VECSXP,length(orders)));
  for(i=0;i<length(orders);i++) {
    SEXP order = VECTOR_ELT(orders,i);
    SEXP invert;
    PROTECT(invert = duplicate(order));
    for(j=0;j<length(order);j++)
      INTEGER(invert)[INTEGER(order)[j]-1] = j+1;
    SET_VECTOR_ELT(ret,i,invert);
    UNPROTECT(1);
  }
  UNPROTECT(1);
  return ret;
}

void RW_SampleDagsFromOrder(DB *dags,SEXP order) {
  char *vmax = vmaxget();
  vmaxset(vmax);
}
